osgFX::Technique Class Referenceabstract

`#include <Technique>`

Inheritance diagram for osgFX::Technique:

## Public Member Functions

| Technique ()
virtual const char * | techniqueName ()
virtual const char * | techniqueDescription ()
virtual void | getRequiredExtensions (std::vector< std::string > &) const
virtual bool | validate (osg::State &) const
int | getNumPasses () const
osg::StateSet * | getPassStateSet (int i)
const osg::StateSet * | getPassStateSet (int i) const
virtual void | traverse (osg::NodeVisitor &nv, Effect *fx)
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
virtual void | setThreadSafeRefUnref (bool)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

| Technique (const Technique &)
virtual | ~Technique ()
Technique & | operator= (const Technique &)
void | dirtyPasses ()
void | addPass (osg::StateSet *ss=0)
virtual osg::Node * | getOverrideChild (int)
virtual void | define_passes ()=0
void | traverse_implementation (osg::NodeVisitor &nv, Effect *fx)
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Detailed Description

This is the base class for effect techniques. A technique represents one of the possible ways to implement a special effect. This base class is abstract, you will have to subclass your own techniques for your custom effects. Derived classes will have to implement the define_passes() method to configure the rendering pass(es) that make up the technique. Usually you will create one StateSet object for each rendering pass and then you'll call addPass(stateset). The validate() method should return true if the technique is valid within the current rendering context, false otherwise. The default implementation of validate() calls getRequiredExtensions() and tests whether all required extensions are supported or not, returning false if at least one extension is not supported.

## Constructor & Destructor Documentation

## Technique() [1/2]

osgFX::Technique::Technique | ( |  | ) |

Referenced by operator=(), and Technique().

## Technique() [2/2]

osgFX::Technique::Technique | ( | const Technique & |  | ) |

inline protected

References osg::Referenced::Referenced(), and Technique().

## ~Technique()

virtual osgFX::Technique::~Technique | ( |  | ) |

inline protected virtual

## Member Function Documentation

## addPass()

void osgFX::Technique::addPass | ( | osg::StateSet * | ss = 0 | ) |

protected

create a new pass node, add it to the technique and associate a StateSet

## define_passes()

virtual void osgFX::Technique::define_passes | ( |  | ) |

protected pure virtual

define the rendering passes that make up this technique. You must implement this method in derived classes to add the required passes.

## dirtyPasses()

void osgFX::Technique::dirtyPasses | ( |  | ) |

inline protected

force rebuilding of pass nodes on next traversal

## getNumPasses()

int osgFX::Technique::getNumPasses | ( |  | ) | const

inline

get the number of rendering passes defined in this Technique

Referenced by validate().

## getOverrideChild()

virtual osg::Node * osgFX::Technique::getOverrideChild | ( | int |  | ) |

inline protected virtual

optional: return a node that overrides the child node on a specified pass

## getPassStateSet() [1/2]

osg::StateSet * osgFX::Technique::getPassStateSet | ( | int | i | ) |

inline

get the StateSet object associated to the i-th pass

Referenced by validate().

## getPassStateSet() [2/2]

const osg::StateSet * osgFX::Technique::getPassStateSet | ( | int | i | ) | const

inline

get the const StateSet object associated to the i-th pass

## getRequiredExtensions()

virtual void osgFX::Technique::getRequiredExtensions | ( | std::vector< std::string > & |  | ) | const

inline virtual

collect the GL extension strings which are required for this technique to work properly. This method is called from the default implementation of validate().

## operator=()

Technique & osgFX::Technique::operator= | ( | const Technique & |  | ) |

inline protected

References Technique().

## techniqueDescription()

virtual const char * osgFX::Technique::techniqueDescription | ( |  | ) |

inline virtual

get a brief description of this Technique

## techniqueName()

virtual const char * osgFX::Technique::techniqueName | ( |  | ) |

inline virtual

get the name of this Technique

## traverse()

void osgFX::Technique::traverse | ( | osg::NodeVisitor & | nv,
|  | Effect * | fx )

inline virtual

traverse children with multipass if necessary. By default this method simply calls the protected method traverse_implementation(); you can override it to change the default behavior. Don't call this method directly as it is called by osgFX::Effect

References traverse_implementation().

Referenced by validate().

## traverse_implementation()

void osgFX::Technique::traverse_implementation | ( | osg::NodeVisitor & | nv,
|  | Effect * | fx )

protected

traverse children with multipass if necessary. Don't call this method directly unless you are in a customized version of traverse().

Referenced by traverse().

## validate()

virtual bool osgFX::Technique::validate | ( | osg::State & |  | ) | const

virtual

tests whether this technique is valid for the current rendering context. The default behavior is to call getRequiredExtensions() and check for extension availability.

References getNumPasses(), getPassStateSet(), and traverse().

The documentation for this class was generated from the following file:

- Technique